## GSocket

GSocket — Low-level socket object

## Functions

gboolean | (*GSocketSourceFunc) ()
GSocket * | g_socket_new ()
GSocket * | g_socket_new_from_fd ()
gboolean | g_socket_bind ()
gboolean | g_socket_listen ()
GSocket * | g_socket_accept ()
gboolean | g_socket_connect ()
gboolean | g_socket_check_connect_result ()
gssize | g_socket_receive ()
gssize | g_socket_receive_from ()
gssize | g_socket_receive_message ()
gint | g_socket_receive_messages ()
gssize | g_socket_receive_with_blocking ()
gssize | g_socket_send ()
gssize | g_socket_send_to ()
gssize | g_socket_send_message ()
gint | g_socket_send_messages ()
gssize | g_socket_send_with_blocking ()
gboolean | g_socket_close ()
gboolean | g_socket_is_closed ()
gboolean | g_socket_shutdown ()
gboolean | g_socket_is_connected ()
GSource * | g_socket_create_source ()
GIOCondition | g_socket_condition_check ()
gboolean | g_socket_condition_wait ()
gboolean | g_socket_condition_timed_wait ()
gssize | g_socket_get_available_bytes ()
void | g_socket_set_listen_backlog ()
gint | g_socket_get_listen_backlog ()
gboolean | g_socket_get_blocking ()
void | g_socket_set_blocking ()
gboolean | g_socket_get_keepalive ()
void | g_socket_set_keepalive ()
guint | g_socket_get_timeout ()
void | g_socket_set_timeout ()
void | g_socket_set_ttl ()
guint | g_socket_get_ttl ()
gboolean | g_socket_get_broadcast ()
void | g_socket_set_broadcast ()
gboolean | g_socket_get_option ()
gboolean | g_socket_set_option ()
GSocketFamily | g_socket_get_family ()
int | g_socket_get_fd ()
GSocketAddress * | g_socket_get_local_address ()
GSocketProtocol | g_socket_get_protocol ()
GSocketAddress * | g_socket_get_remote_address ()
GSocketType | g_socket_get_socket_type ()
gboolean | g_socket_speaks_ipv4 ()
GCredentials * | g_socket_get_credentials ()
gboolean | g_socket_join_multicast_group ()
gboolean | g_socket_leave_multicast_group ()
gboolean | g_socket_get_multicast_loopback ()
void | g_socket_set_multicast_loopback ()
guint | g_socket_get_multicast_ttl ()
void | g_socket_set_multicast_ttl ()

## Properties

gboolean | blocking | Read / Write
gboolean | broadcast | Read / Write
GSocketFamily | family | Read / Write / Construct Only
gint | fd | Read / Write / Construct Only
gboolean | keepalive | Read / Write
gint | listen-backlog | Read / Write
GSocketAddress * | local-address | Read
gboolean | multicast-loopback | Read / Write
guint | multicast-ttl | Read / Write
GSocketProtocol | protocol | Read / Write / Construct Only
GSocketAddress * | remote-address | Read
guint | timeout | Read / Write
guint | ttl | Read / Write
GSocketType | type | Read / Write / Construct Only

## Types and Values

| GSocket
enum | GSocketType
enum | GSocketProtocol
enum | GSocketMsgFlags
struct | GInputVector
struct | GInputMessage
struct | GOutputVector
struct | GOutputMessage

## Object Hierarchy

        GObject
        ╰── GSocket

## Implemented Interfaces

GSocket implements GInitable and GDatagramBased.

## Includes

    #include <gio/gio.h>

## Description

A GSocket is a low-level networking primitive. It is a more or less direct mapping of the BSD socket API in a portable GObject based API. It supports both the UNIX socket implementations and winsock2 on Windows.

GSocket is the platform independent base upon which the higher level network primitives are based. Applications are not typically meant to use it directly, but rather through classes like GSocketClient, GSocketService and GSocketConnection. However there may be cases where direct use of GSocket is useful.

GSocket implements the GInitable interface, so if it is manually constructed by e.g. `g_object_new()` you must call `g_initable_init()` and check the results before using the object. This is done automatically in `g_socket_new()` and `g_socket_new_from_fd()`, so these functions can return `NULL`.

Sockets operate in two general modes, blocking or non-blocking. When in blocking mode all operations (which don’t take an explicit blocking parameter) block until the requested operation is finished or there is an error. In non-blocking mode all calls that would block return immediately with a `G_IO_ERROR_WOULD_BLOCK` error. To know when a call would successfully run you can call `g_socket_condition_check()`, or `g_socket_condition_wait()`. You can also use `g_socket_create_source()` and attach it to a GMainContext to get callbacks when I/O is possible. Note that all sockets are always set to non blocking mode in the system, and blocking mode is emulated in GSocket.

When working in non-blocking mode applications should always be able to handle getting a `G_IO_ERROR_WOULD_BLOCK` error even when some other function said that I/O was possible. This can easily happen in case of a race condition in the application, but it can also happen for other reasons. For instance, on Windows a socket is always seen as writable until a write returns `G_IO_ERROR_WOULD_BLOCK`.

GSockets can be either connection oriented or datagram based. For connection oriented types you must first establish a connection by either connecting to an address or accepting a connection from another address. For connectionless socket types the target/source address is specified or received in each I/O operation.

All socket file descriptors are set to be close-on-exec.

Note that creating a GSocket causes the signal `SIGPIPE` to be ignored for the remainder of the program. If you are writing a command-line utility that uses GSocket, you may need to take into account the fact that your program will not automatically be killed if it tries to write to `stdout` after it has been closed.

Like most other APIs in GLib, GSocket is not inherently thread safe. To use a GSocket concurrently from multiple threads, you must implement your own locking.

## Functions

### GSocketSourceFunc ()

    gboolean
    (*GSocketSourceFunc) (GSocket *socket,
                          GIOCondition condition,
                          gpointer user_data);

This is the function type of the callback used for the GSource returned by `g_socket_create_source()`.

#### Parameters

socket | the GSocket |
condition | the current condition at the source fired. |
user_data | data passed in by the user. |

#### Returns

it should return `FALSE` if the source should be removed.

Since: 2.22

### g_socket_new ()

    GSocket *
    g_socket_new (GSocketFamily family,
                  GSocketType type,
                  GSocketProtocol protocol,
                  GError **error);

Creates a new GSocket with the defined family, type and protocol. If `protocol` is 0 (`G_SOCKET_PROTOCOL_DEFAULT`) the default protocol type for the family and type is used.

The `protocol` is a family and type specific int that specifies what kind of protocol to use. GSocketProtocol lists several common ones. Many families only support one protocol, and use 0 for this, others support several and using 0 means to use the default protocol for the family and type.

The protocol id is passed directly to the operating system, so you can use protocols not listed in GSocketProtocol if you know the protocol number used for it.

#### Parameters

family | the socket family to use, e.g. `G_SOCKET_FAMILY_IPV4`. |
type | the socket type to use. |
protocol | the id of the protocol to use, or 0 for default. |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

a GSocket or `NULL` on error. Free the returned object with `g_object_unref()`.

Since: 2.22

### g_socket_new_from_fd ()

    GSocket *
    g_socket_new_from_fd (gint fd,
                          GError **error);

Creates a new GSocket from a native file descriptor or winsock SOCKET handle.

This reads all the settings from the file descriptor so that all properties should work. Note that the file descriptor will be set to non-blocking mode, independent on the blocking mode of the GSocket.

On success, the returned GSocket takes ownership of `fd` . On failure, the caller must close `fd` themselves.

Since GLib 2.46, it is no longer a fatal error to call this on a non-socket descriptor. Instead, a GError will be set with code `G_IO_ERROR_FAILED`

#### Parameters

fd | a native socket file descriptor. |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

a GSocket or `NULL` on error. Free the returned object with `g_object_unref()`.

Since: 2.22

### g_socket_bind ()

    gboolean
    g_socket_bind (GSocket *socket,
                   GSocketAddress *address,
                   gboolean allow_reuse,
                   GError **error);

When a socket is created it is attached to an address family, but it doesn't have an address in this family. `g_socket_bind()` assigns the address (sometimes called name) of the socket.

It is generally required to bind to a local address before you can receive connections. (See `g_socket_listen()` and `g_socket_accept()` ). In certain situations, you may also want to bind a socket that will be used to initiate connections, though this is not normally required.

If `socket` is a TCP socket, then `allow_reuse` controls the setting of the `SO_REUSEADDR` socket option; normally it should be `TRUE` for server sockets (sockets that you will eventually call `g_socket_accept()` on), and `FALSE` for client sockets. (Failing to set this flag on a server socket may cause `g_socket_bind()` to return `G_IO_ERROR_ADDRESS_IN_USE` if the server program is stopped and then immediately restarted.)

If `socket` is a UDP socket, then `allow_reuse` determines whether or not other UDP sockets can be bound to the same address at the same time. In particular, you can have several UDP sockets bound to the same address, and they will all receive all of the multicast and broadcast packets sent to that address. (The behavior of unicast UDP packets to an address with multiple listeners is not defined.)

#### Parameters

socket | a GSocket. |
address | a GSocketAddress specifying the local address. |
allow_reuse | whether to allow reusing this address |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` on error.

Since: 2.22

### g_socket_listen ()

    gboolean
    g_socket_listen (GSocket *socket,
                     GError **error);

Marks the socket as a server socket, i.e. a socket that is used to accept incoming requests using `g_socket_accept()`.

Before calling this the socket must be bound to a local address using `g_socket_bind()`.

To set the maximum amount of outstanding clients, use `g_socket_set_listen_backlog()`.

#### Parameters

socket | a GSocket. |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` on error.

Since: 2.22

### g_socket_accept ()

    GSocket *
    g_socket_accept (GSocket *socket,
                     GCancellable *cancellable,
                     GError **error);

Accept incoming connections on a connection-based socket. This removes the first outstanding connection request from the listening socket and creates a GSocket object for it.

The `socket` must be bound to a local address with `g_socket_bind()` and must be listening for incoming connections (`g_socket_listen()`).

If there are no outstanding connections then the operation will block or return `G_IO_ERROR_WOULD_BLOCK` if non-blocking I/O is enabled. To be notified of an incoming connection, wait for the `G_IO_IN` condition.

#### Parameters

socket | a GSocket. |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

a new GSocket, or `NULL` on error. Free the returned object with `g_object_unref()`.

[transfer full]

Since: 2.22

### g_socket_connect ()

    gboolean
    g_socket_connect (GSocket *socket,
                      GSocketAddress *address,
                      GCancellable *cancellable,
                      GError **error);

Connect the socket to the specified remote address.

For connection oriented socket this generally means we attempt to make a connection to the `address` . For a connection-less socket it sets the default address for `g_socket_send()` and discards all incoming datagrams from other sources.

Generally connection oriented sockets can only connect once, but connection-less sockets can connect multiple times to change the default address.

If the connect call needs to do network I/O it will block, unless non-blocking I/O is enabled. Then `G_IO_ERROR_PENDING` is returned and the user can be notified of the connection finishing by waiting for the G_IO_OUT condition. The result of the connection must then be checked with `g_socket_check_connect_result()`.

#### Parameters

socket | a GSocket. |
address | a GSocketAddress specifying the remote address. |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` if connected, `FALSE` on error.

Since: 2.22

### g_socket_check_connect_result ()

    gboolean
    g_socket_check_connect_result (GSocket *socket,
                                   GError **error);

Checks and resets the pending connect error for the socket. This is used to check for errors when `g_socket_connect()` is used in non-blocking mode.

#### Parameters

socket | a GSocket |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` if no error, `FALSE` otherwise, setting `error` to the error

Since: 2.22

### g_socket_receive ()

    gssize
    g_socket_receive (GSocket *socket,
                      gchar *buffer,
                      gsize size,
                      GCancellable *cancellable,
                      GError **error);

Receive data (up to `size` bytes) from a socket. This is mainly used by connection-oriented sockets; it is identical to `g_socket_receive_from()` with `address` set to `NULL`.

For `G_SOCKET_TYPE_DATAGRAM` and `G_SOCKET_TYPE_SEQPACKET` sockets, `g_socket_receive()` will always read either 0 or 1 complete messages from the socket. If the received message is too large to fit in `buffer` , then the data beyond `size` bytes will be discarded, without any explicit indication that this has occurred.

For `G_SOCKET_TYPE_STREAM` sockets, `g_socket_receive()` can return any number of bytes, up to `size` . If more than `size` bytes have been received, the additional data will be returned in future calls to `g_socket_receive()`.

If the socket is in blocking mode the call will block until there is some data to receive, the connection is closed, or there is an error. If there is no data available and the socket is in non-blocking mode, a `G_IO_ERROR_WOULD_BLOCK` error will be returned. To be notified when data is available, wait for the `G_IO_IN` condition.

On error -1 is returned and `error` is set accordingly.

#### Parameters

socket | a GSocket |
buffer | a buffer to read data into (which should be at least `size` bytes long). | [array length=size][element-type guint8]
size | the number of bytes you want to read from the socket |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes read, or 0 if the connection was closed by the peer, or -1 on error

Since: 2.22

### g_socket_receive_from ()

    gssize
    g_socket_receive_from (GSocket *socket,
                           GSocketAddress **address,
                           gchar *buffer,
                           gsize size,
                           GCancellable *cancellable,
                           GError **error);

Receive data (up to `size` bytes) from a socket.

If `address` is non-`NULL` then `address` will be set equal to the source address of the received packet. `address` is owned by the caller.

See `g_socket_receive()` for additional information.

#### Parameters

socket | a GSocket |
address | a pointer to a GSocketAddress pointer, or `NULL`. | [out][allow-none]
buffer | a buffer to read data into (which should be at least `size` bytes long). | [array length=size][element-type guint8]
size | the number of bytes you want to read from the socket |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes read, or 0 if the connection was closed by the peer, or -1 on error

Since: 2.22

### g_socket_receive_message ()

    gssize
    g_socket_receive_message (GSocket *socket,
                              GSocketAddress **address,
                              GInputVector *vectors,
                              gint num_vectors,
                              GSocketControlMessage ***messages,
                              gint *num_messages,
                              gint *flags,
                              GCancellable *cancellable,
                              GError **error);

Receive data from a socket. For receiving multiple messages, see `g_socket_receive_messages()`; for easier use, see `g_socket_receive()` and `g_socket_receive_from()`.

If `address` is non-`NULL` then `address` will be set equal to the source address of the received packet. `address` is owned by the caller.

`vector` must point to an array of GInputVector structs and `num_vectors` must be the length of this array. These structs describe the buffers that received data will be scattered into. If `num_vectors` is -1, then `vectors` is assumed to be terminated by a GInputVector with a `NULL` buffer pointer.

As a special case, if `num_vectors` is 0 (in which case, `vectors` may of course be `NULL`), then a single byte is received and discarded. This is to facilitate the common practice of sending a single '\0' byte for the purposes of transferring ancillary data.

`messages` , if non-`NULL`, will be set to point to a newly-allocated array of GSocketControlMessage instances or `NULL` if no such messages was received. These correspond to the control messages received from the kernel, one GSocketControlMessage per message from the kernel. This array is `NULL`-terminated and must be freed by the caller using `g_free()` after calling `g_object_unref()` on each element. If `messages` is `NULL`, any control messages received will be discarded.

`num_messages` , if non-`NULL`, will be set to the number of control messages received.

If both `messages` and `num_messages` are non-`NULL`, then `num_messages` gives the number of GSocketControlMessage instances in `messages` (ie: not including the `NULL` terminator).

`flags` is an in/out parameter. The commonly available arguments for this are available in the GSocketMsgFlags enum, but the values there are the same as the system values, and the flags are passed in as-is, so you can pass in system-specific flags too (and `g_socket_receive_message()` may pass system-specific flags out). Flags passed in to the parameter affect the receive operation; flags returned out of it are relevant to the specific returned message.

As with `g_socket_receive()`, data may be discarded if `socket` is `G_SOCKET_TYPE_DATAGRAM` or `G_SOCKET_TYPE_SEQPACKET` and you do not provide enough buffer space to read a complete message. You can pass `G_SOCKET_MSG_PEEK` in `flags` to peek at the current message without removing it from the receive queue, but there is no portable way to find out the length of the message other than by reading it into a sufficiently-large buffer.

If the socket is in blocking mode the call will block until there is some data to receive, the connection is closed, or there is an error. If there is no data available and the socket is in non-blocking mode, a `G_IO_ERROR_WOULD_BLOCK` error will be returned. To be notified when data is available, wait for the `G_IO_IN` condition.

On error -1 is returned and `error` is set accordingly.

#### Parameters

socket | a GSocket |
address | a pointer to a GSocketAddress pointer, or `NULL`. | [out][nullable]
vectors | an array of GInputVector structs. | [array length=num_vectors]
num_vectors | the number of elements in `vectors` , or -1 |
messages | a pointer which may be filled with an array of GSocketControlMessages, or `NULL`. | [array length=num_messages][out][nullable]
num_messages | a pointer which will be filled with the number of elements in `messages` , or `NULL`. | [out]
flags | a pointer to an int containing GSocketMsgFlags flags. | [inout]
cancellable | a `GCancellable` or `NULL` |
error | a GError pointer, or `NULL` |

#### Returns

Number of bytes read, or 0 if the connection was closed by the peer, or -1 on error

Since: 2.22

### g_socket_receive_messages ()

    gint
    g_socket_receive_messages (GSocket *socket,
                               GInputMessage *messages,
                               guint num_messages,
                               gint flags,
                               GCancellable *cancellable,
                               GError **error);

Receive multiple data messages from `socket` in one go. This is the most complicated and fully-featured version of this call. For easier use, see `g_socket_receive()`, `g_socket_receive_from()`, and `g_socket_receive_message()`.

`messages` must point to an array of GInputMessage structs and `num_messages` must be the length of this array. Each GInputMessage contains a pointer to an array of GInputVector structs describing the buffers that the data received in each message will be written to. Using multiple GInputVectors is more memory-efficient than manually copying data out of a single buffer to multiple sources, and more system-call-efficient than making multiple calls to `g_socket_receive()`, such as in scenarios where a lot of data packets need to be received (e.g. high-bandwidth video streaming over RTP/UDP).

`flags` modify how all messages are received. The commonly available arguments for this are available in the GSocketMsgFlags enum, but the values there are the same as the system values, and the flags are passed in as-is, so you can pass in system-specific flags too. These flags affect the overall receive operation. Flags affecting individual messages are returned in GInputMessage.flags.

The other members of GInputMessage are treated as described in its documentation.

If “blocking” is `TRUE` the call will block until `num_messages` have been received, or the end of the stream is reached.

If “blocking” is `FALSE` the call will return up to `num_messages` without blocking, or `G_IO_ERROR_WOULD_BLOCK` if no messages are queued in the operating system to be received.

In blocking mode, if “timeout” is positive and is reached before any messages are received, `G_IO_ERROR_TIMED_OUT` is returned, otherwise up to `num_messages` are returned. (Note: This is effectively the behaviour of `MSG_WAITFORONE` with `recvmmsg()`.)

To be notified when messages are available, wait for the `G_IO_IN` condition. Note though that you may still receive `G_IO_ERROR_WOULD_BLOCK` from `g_socket_receive_messages()` even if you were previously notified of a `G_IO_IN` condition.

If the remote peer closes the connection, any messages queued in the operating system will be returned, and subsequent calls to `g_socket_receive_messages()` will return 0 (with no error set).

On error -1 is returned and `error` is set accordingly. An error will only be returned if zero messages could be received; otherwise the number of messages successfully received before the error will be returned.

#### Parameters

socket | a GSocket |
messages | an array of GInputMessage structs. | [array length=num_messages]
num_messages | the number of elements in `messages` |
flags | an int containing GSocketMsgFlags flags for the overall operation |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore |

#### Returns

number of messages received, or -1 on error. Note that the number of messages received may be smaller than `num_messages` if in non-blocking mode, if the peer closed the connection, or if `num_messages` was larger than `UIO_MAXIOV` (1024), in which case the caller may re-try to receive the remaining messages.

Since: 2.48

### g_socket_receive_with_blocking ()

    gssize
    g_socket_receive_with_blocking (GSocket *socket,
                                    gchar *buffer,
                                    gsize size,
                                    gboolean blocking,
                                    GCancellable *cancellable,
                                    GError **error);

This behaves exactly the same as `g_socket_receive()`, except that the choice of blocking or non-blocking behavior is determined by the `blocking` argument rather than by `socket` 's properties.

#### Parameters

socket | a GSocket |
buffer | a buffer to read data into (which should be at least `size` bytes long). | [array length=size][element-type guint8]
size | the number of bytes you want to read from the socket |
blocking | whether to do blocking or non-blocking I/O |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes read, or 0 if the connection was closed by the peer, or -1 on error

Since: 2.26

### g_socket_send ()

    gssize
    g_socket_send (GSocket *socket,
                   const gchar *buffer,
                   gsize size,
                   GCancellable *cancellable,
                   GError **error);

Tries to send `size` bytes from `buffer` on the socket. This is mainly used by connection-oriented sockets; it is identical to `g_socket_send_to()` with `address` set to `NULL`.

If the socket is in blocking mode the call will block until there is space for the data in the socket queue. If there is no space available and the socket is in non-blocking mode a `G_IO_ERROR_WOULD_BLOCK` error will be returned. To be notified when space is available, wait for the `G_IO_OUT` condition. Note though that you may still receive `G_IO_ERROR_WOULD_BLOCK` from `g_socket_send()` even if you were previously notified of a `G_IO_OUT` condition. (On Windows in particular, this is very common due to the way the underlying APIs work.)

On error -1 is returned and `error` is set accordingly.

#### Parameters

socket | a GSocket |
buffer | the buffer containing the data to send. | [array length=size][element-type guint8]
size | the number of bytes to send |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes written (which may be less than `size` ), or -1 on error

Since: 2.22

### g_socket_send_to ()

    gssize
    g_socket_send_to (GSocket *socket,
                      GSocketAddress *address,
                      const gchar *buffer,
                      gsize size,
                      GCancellable *cancellable,
                      GError **error);

Tries to send `size` bytes from `buffer` to `address` . If `address` is `NULL` then the message is sent to the default receiver (set by `g_socket_connect()`).

See `g_socket_send()` for additional information.

#### Parameters

socket | a GSocket |
address | a GSocketAddress, or `NULL`. | [allow-none]
buffer | the buffer containing the data to send. | [array length=size][element-type guint8]
size | the number of bytes to send |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes written (which may be less than `size` ), or -1 on error

Since: 2.22

### g_socket_send_message ()

    gssize
    g_socket_send_message (GSocket *socket,
                           GSocketAddress *address,
                           GOutputVector *vectors,
                           gint num_vectors,
                           GSocketControlMessage **messages,
                           gint num_messages,
                           gint flags,
                           GCancellable *cancellable,
                           GError **error);

Send data to `address` on `socket` . For sending multiple messages see `g_socket_send_messages()`; for easier use, see `g_socket_send()` and `g_socket_send_to()`.

If `address` is `NULL` then the message is sent to the default receiver (set by `g_socket_connect()`).

`vectors` must point to an array of GOutputVector structs and `num_vectors` must be the length of this array. (If `num_vectors` is -1, then `vectors` is assumed to be terminated by a GOutputVector with a `NULL` buffer pointer.) The GOutputVector structs describe the buffers that the sent data will be gathered from. Using multiple GOutputVectors is more memory-efficient than manually copying data from multiple sources into a single buffer, and more network-efficient than making multiple calls to `g_socket_send()`.

`messages` , if non-`NULL`, is taken to point to an array of `num_messages` GSocketControlMessage instances. These correspond to the control messages to be sent on the socket. If `num_messages` is -1 then `messages` is treated as a `NULL`-terminated array.

`flags` modify how the message is sent. The commonly available arguments for this are available in the GSocketMsgFlags enum, but the values there are the same as the system values, and the flags are passed in as-is, so you can pass in system-specific flags too.

If the socket is in blocking mode the call will block until there is space for the data in the socket queue. If there is no space available and the socket is in non-blocking mode a `G_IO_ERROR_WOULD_BLOCK` error will be returned. To be notified when space is available, wait for the `G_IO_OUT` condition. Note though that you may still receive `G_IO_ERROR_WOULD_BLOCK` from `g_socket_send()` even if you were previously notified of a `G_IO_OUT` condition. (On Windows in particular, this is very common due to the way the underlying APIs work.)

On error -1 is returned and `error` is set accordingly.

#### Parameters

socket | a GSocket |
address | a GSocketAddress, or `NULL`. | [allow-none]
vectors | an array of GOutputVector structs. | [array length=num_vectors]
num_vectors | the number of elements in `vectors` , or -1 |
messages | a pointer to an array of GSocketControlMessages, or `NULL`. | [array length=num_messages][allow-none]
num_messages | number of elements in `messages` , or -1. |
flags | an int containing GSocketMsgFlags flags |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes written (which may be less than `size` ), or -1 on error

Since: 2.22

### g_socket_send_messages ()

    gint
    g_socket_send_messages (GSocket *socket,
                            GOutputMessage *messages,
                            guint num_messages,
                            gint flags,
                            GCancellable *cancellable,
                            GError **error);

Send multiple data messages from `socket` in one go. This is the most complicated and fully-featured version of this call. For easier use, see `g_socket_send()`, `g_socket_send_to()`, and `g_socket_send_message()`.

`messages` must point to an array of GOutputMessage structs and `num_messages` must be the length of this array. Each GOutputMessage contains an address to send the data to, and a pointer to an array of GOutputVector structs to describe the buffers that the data to be sent for each message will be gathered from. Using multiple GOutputVectors is more memory-efficient than manually copying data from multiple sources into a single buffer, and more network-efficient than making multiple calls to `g_socket_send()`. Sending multiple messages in one go avoids the overhead of making a lot of syscalls in scenarios where a lot of data packets need to be sent (e.g. high-bandwidth video streaming over RTP/UDP), or where the same data needs to be sent to multiple recipients.

`flags` modify how the message is sent. The commonly available arguments for this are available in the GSocketMsgFlags enum, but the values there are the same as the system values, and the flags are passed in as-is, so you can pass in system-specific flags too.

If the socket is in blocking mode the call will block until there is space for all the data in the socket queue. If there is no space available and the socket is in non-blocking mode a `G_IO_ERROR_WOULD_BLOCK` error will be returned if no data was written at all, otherwise the number of messages sent will be returned. To be notified when space is available, wait for the `G_IO_OUT` condition. Note though that you may still receive `G_IO_ERROR_WOULD_BLOCK` from `g_socket_send()` even if you were previously notified of a `G_IO_OUT` condition. (On Windows in particular, this is very common due to the way the underlying APIs work.)

On error -1 is returned and `error` is set accordingly. An error will only be returned if zero messages could be sent; otherwise the number of messages successfully sent before the error will be returned.

#### Parameters

socket | a GSocket |
messages | an array of GOutputMessage structs. | [array length=num_messages]
num_messages | the number of elements in `messages` |
flags | an int containing GSocketMsgFlags flags |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

number of messages sent, or -1 on error. Note that the number of messages sent may be smaller than `num_messages` if the socket is non-blocking or if `num_messages` was larger than UIO_MAXIOV (1024), in which case the caller may re-try to send the remaining messages.

Since: 2.44

### g_socket_send_with_blocking ()

    gssize
    g_socket_send_with_blocking (GSocket *socket,
                                 const gchar *buffer,
                                 gsize size,
                                 gboolean blocking,
                                 GCancellable *cancellable,
                                 GError **error);

This behaves exactly the same as `g_socket_send()`, except that the choice of blocking or non-blocking behavior is determined by the `blocking` argument rather than by `socket` 's properties.

#### Parameters

socket | a GSocket |
buffer | the buffer containing the data to send. | [array length=size][element-type guint8]
size | the number of bytes to send |
blocking | whether to do blocking or non-blocking I/O |
cancellable | a `GCancellable` or `NULL`. | [allow-none]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

Number of bytes written (which may be less than `size` ), or -1 on error

Since: 2.26

### g_socket_close ()

    gboolean
    g_socket_close (GSocket *socket,
                    GError **error);

Closes the socket, shutting down any active connection.

Closing a socket does not wait for all outstanding I/O operations to finish, so the caller should not rely on them to be guaranteed to complete even if the close returns with no error.

Once the socket is closed, all other operations will return `G_IO_ERROR_CLOSED`. Closing a socket multiple times will not return an error.

Sockets will be automatically closed when the last reference is dropped, but you might want to call this function to make sure resources are released as early as possible.

Beware that due to the way that TCP works, it is possible for recently-sent data to be lost if either you close a socket while the `G_IO_IN` condition is set, or else if the remote connection tries to send something to you after you close the socket but before it has finished reading all of the data you sent. There is no easy generic way to avoid this problem; the easiest fix is to design the network protocol such that the client will never send data "out of turn". Another solution is for the server to half-close the connection by calling `g_socket_shutdown()` with only the `shutdown_write` flag set, and then wait for the client to notice this and close its side of the connection, after which the server can safely call `g_socket_close()`. (This is what GTcpConnection does if you call `g_tcp_connection_set_graceful_disconnect()`. But of course, this only works if the client will close its connection after the server does.)

#### Parameters

socket | a GSocket |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` on error

Since: 2.22

### g_socket_is_closed ()

    gboolean
    g_socket_is_closed (GSocket *socket);

Checks whether a socket is closed.

#### Parameters

socket | a GSocket |

#### Returns

`TRUE` if socket is closed, `FALSE` otherwise

Since: 2.22

### g_socket_shutdown ()

    gboolean
    g_socket_shutdown (GSocket *socket,
                       gboolean shutdown_read,
                       gboolean shutdown_write,
                       GError **error);

Shut down part or all of a full-duplex connection.

If `shutdown_read` is `TRUE` then the receiving side of the connection is shut down, and further reading is disallowed.

If `shutdown_write` is `TRUE` then the sending side of the connection is shut down, and further writing is disallowed.

It is allowed for both `shutdown_read` and `shutdown_write` to be `TRUE`.

One example where it is useful to shut down only one side of a connection is graceful disconnect for TCP connections where you close the sending side, then wait for the other side to close the connection, thus ensuring that the other side saw all sent data.

#### Parameters

socket | a GSocket |
shutdown_read | whether to shut down the read side |
shutdown_write | whether to shut down the write side |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` on error

Since: 2.22

### g_socket_is_connected ()

    gboolean
    g_socket_is_connected (GSocket *socket);

Check whether the socket is connected. This is only useful for connection-oriented sockets.

If using `g_socket_shutdown()`, this function will return `TRUE` until the socket has been shut down for reading and writing. If you do a non-blocking connect, this function will not return `TRUE` until after you call `g_socket_check_connect_result()`.

#### Parameters

socket | a GSocket. |

#### Returns

`TRUE` if socket is connected, `FALSE` otherwise.

Since: 2.22

### g_socket_create_source ()

    GSource *
    g_socket_create_source (GSocket *socket,
                            GIOCondition condition,
                            GCancellable *cancellable);

Creates a GSource that can be attached to a `GMainContext` to monitor for the availability of the specified `condition` on the socket. The GSource keeps a reference to the `socket` .

The callback on the source is of the GSocketSourceFunc type.

It is meaningless to specify `G_IO_ERR` or `G_IO_HUP` in `condition` ; these conditions will always be reported output if they are true.

`cancellable` if not `NULL` can be used to cancel the source, which will cause the source to trigger, reporting the current condition (which is likely 0 unless cancellation happened at the same time as a condition change). You can check for this in the callback using `g_cancellable_is_cancelled()`.

If `socket` has a timeout set, and it is reached before `condition` occurs, the source will then trigger anyway, reporting `G_IO_IN` or `G_IO_OUT` depending on `condition` . However, `socket` will have been marked as having had a timeout, and so the next GSocket I/O method you call will then fail with a `G_IO_ERROR_TIMED_OUT`.

[skip]

#### Parameters

socket | a GSocket |
condition | a GIOCondition mask to monitor |
cancellable | a `GCancellable` or `NULL`. | [allow-none]

#### Returns

a newly allocated `GSource`, free with `g_source_unref()`.

[transfer full]

Since: 2.22

### g_socket_condition_check ()

    GIOCondition
    g_socket_condition_check (GSocket *socket,
                              GIOCondition condition);

Checks on the readiness of `socket` to perform operations. The operations specified in `condition` are checked for and masked against the currently-satisfied conditions on `socket` . The result is returned.

Note that on Windows, it is possible for an operation to return `G_IO_ERROR_WOULD_BLOCK` even immediately after `g_socket_condition_check()` has claimed that the socket is ready for writing. Rather than calling `g_socket_condition_check()` and then writing to the socket if it succeeds, it is generally better to simply try writing to the socket right away, and try again later if the initial attempt returns `G_IO_ERROR_WOULD_BLOCK`.

It is meaningless to specify `G_IO_ERR` or `G_IO_HUP` in condition; these conditions will always be set in the output if they are true.

This call never blocks.

#### Parameters

socket | a GSocket |
condition | a GIOCondition mask to check |

#### Returns

the `GIOCondition` mask of the current state

Since: 2.22

### g_socket_condition_wait ()

    gboolean
    g_socket_condition_wait (GSocket *socket,
                             GIOCondition condition,
                             GCancellable *cancellable,
                             GError **error);

Waits for `condition` to become true on `socket` . When the condition is met, `TRUE` is returned.

If `cancellable` is cancelled before the condition is met, or if the socket has a timeout set and it is reached before the condition is met, then `FALSE` is returned and `error` , if non-`NULL`, is set to the appropriate value (`G_IO_ERROR_CANCELLED` or `G_IO_ERROR_TIMED_OUT`).

See also `g_socket_condition_timed_wait()`.

#### Parameters

socket | a GSocket |
condition | a GIOCondition mask to wait for |
cancellable | a GCancellable, or `NULL`. | [allow-none]
error | a GError pointer, or `NULL` |

#### Returns

`TRUE` if the condition was met, `FALSE` otherwise

Since: 2.22

### g_socket_condition_timed_wait ()

    gboolean
    g_socket_condition_timed_wait (GSocket *socket,
                                   GIOCondition condition,
                                   gint64 timeout,
                                   GCancellable *cancellable,
                                   GError **error);

Waits for up to `timeout` microseconds for `condition` to become true on `socket` . If the condition is met, `TRUE` is returned.

If `cancellable` is cancelled before the condition is met, or if `timeout` (or the socket's “timeout”) is reached before the condition is met, then `FALSE` is returned and `error` , if non-`NULL`, is set to the appropriate value (`G_IO_ERROR_CANCELLED` or `G_IO_ERROR_TIMED_OUT`).

If you don't want a timeout, use `g_socket_condition_wait()`. (Alternatively, you can pass -1 for `timeout` .)

Note that although `timeout` is in microseconds for consistency with other GLib APIs, this function actually only has millisecond resolution, and the behavior is undefined if `timeout` is not an exact number of milliseconds.

#### Parameters

socket | a GSocket |
condition | a GIOCondition mask to wait for |
timeout | the maximum time (in microseconds) to wait, or -1 |
cancellable | a GCancellable, or `NULL`. | [allow-none]
error | a GError pointer, or `NULL` |

#### Returns

`TRUE` if the condition was met, `FALSE` otherwise

Since: 2.32

### g_socket_get_available_bytes ()

    gssize
    g_socket_get_available_bytes (GSocket *socket);

Get the amount of data pending in the OS input buffer, without blocking.

If `socket` is a UDP or SCTP socket, this will return the size of just the next packet, even if additional packets are buffered after that one.

Note that on Windows, this function is rather inefficient in the UDP case, and so if you know any plausible upper bound on the size of the incoming packet, it is better to just do a `g_socket_receive()` with a buffer of that size, rather than calling `g_socket_get_available_bytes()` first and then doing a receive of exactly the right size.

#### Parameters

socket | a GSocket |

#### Returns

the number of bytes that can be read from the socket without blocking or truncating, or -1 on error.

Since: 2.32

### g_socket_set_listen_backlog ()

    void
    g_socket_set_listen_backlog (GSocket *socket,
                                 gint backlog);

Sets the maximum number of outstanding connections allowed when listening on this socket. If more clients than this are connecting to the socket and the application is not handling them on time then the new connections will be refused.

Note that this must be called before `g_socket_listen()` and has no effect if called after that.

#### Parameters

socket | a GSocket. |
backlog | the maximum number of pending connections. |

Since: 2.22

### g_socket_get_listen_backlog ()

    gint
    g_socket_get_listen_backlog (GSocket *socket);

Gets the listen backlog setting of the socket. For details on this, see `g_socket_set_listen_backlog()`.

#### Parameters

socket | a GSocket. |

#### Returns

the maximum number of pending connections.

Since: 2.22

### g_socket_get_blocking ()

    gboolean
    g_socket_get_blocking (GSocket *socket);

Gets the blocking mode of the socket. For details on blocking I/O, see `g_socket_set_blocking()`.

#### Parameters

socket | a GSocket. |

#### Returns

`TRUE` if blocking I/O is used, `FALSE` otherwise.

Since: 2.22

### g_socket_set_blocking ()

    void
    g_socket_set_blocking (GSocket *socket,
                           gboolean blocking);

Sets the blocking mode of the socket. In blocking mode all operations (which don’t take an explicit blocking parameter) block until they succeed or there is an error. In non-blocking mode all functions return results immediately or with a `G_IO_ERROR_WOULD_BLOCK` error.

All sockets are created in blocking mode. However, note that the platform level socket is always non-blocking, and blocking mode is a GSocket level feature.

#### Parameters

socket | a GSocket. |
blocking | Whether to use blocking I/O or not. |

Since: 2.22

### g_socket_get_keepalive ()

    gboolean
    g_socket_get_keepalive (GSocket *socket);

Gets the keepalive mode of the socket. For details on this, see `g_socket_set_keepalive()`.

#### Parameters

socket | a GSocket. |

#### Returns

`TRUE` if keepalive is active, `FALSE` otherwise.

Since: 2.22

### g_socket_set_keepalive ()

    void
    g_socket_set_keepalive (GSocket *socket,
                            gboolean keepalive);

Sets or unsets the `SO_KEEPALIVE` flag on the underlying socket. When this flag is set on a socket, the system will attempt to verify that the remote socket endpoint is still present if a sufficiently long period of time passes with no data being exchanged. If the system is unable to verify the presence of the remote endpoint, it will automatically close the connection.

This option is only functional on certain kinds of sockets. (Notably, `G_SOCKET_PROTOCOL_TCP` sockets.)

The exact time between pings is system- and protocol-dependent, but will normally be at least two hours. Most commonly, you would set this flag on a server socket if you want to allow clients to remain idle for long periods of time, but also want to ensure that connections are eventually garbage-collected if clients crash or become unreachable.

#### Parameters

socket | a GSocket. |
keepalive | Value for the keepalive flag |

Since: 2.22

### g_socket_get_timeout ()

    guint
    g_socket_get_timeout (GSocket *socket);

Gets the timeout setting of the socket. For details on this, see `g_socket_set_timeout()`.

#### Parameters

socket | a GSocket. |

#### Returns

the timeout in seconds

Since: 2.26

### g_socket_set_timeout ()

    void
    g_socket_set_timeout (GSocket *socket,
                          guint timeout);

Sets the time in seconds after which I/O operations on `socket` will time out if they have not yet completed.

On a blocking socket, this means that any blocking GSocket operation will time out after `timeout` seconds of inactivity, returning `G_IO_ERROR_TIMED_OUT`.

On a non-blocking socket, calls to `g_socket_condition_wait()` will also fail with `G_IO_ERROR_TIMED_OUT` after the given time. Sources created with `g_socket_create_source()` will trigger after `timeout` seconds of inactivity, with the requested condition set, at which point calling `g_socket_receive()`, `g_socket_send()`, `g_socket_check_connect_result()`, etc, will fail with `G_IO_ERROR_TIMED_OUT`.

If `timeout` is 0 (the default), operations will never time out on their own.

Note that if an I/O operation is interrupted by a signal, this may cause the timeout to be reset.

#### Parameters

socket | a GSocket. |
timeout | the timeout for `socket` , in seconds, or 0 for none |

Since: 2.26

### g_socket_set_ttl ()

    void
    g_socket_set_ttl (GSocket *socket,
                      guint ttl);

Sets the time-to-live for outgoing unicast packets on `socket` . By default the platform-specific default value is used.

#### Parameters

socket | a GSocket. |
ttl | the time-to-live value for all unicast packets on `socket` |

Since: 2.32

### g_socket_get_ttl ()

    guint
    g_socket_get_ttl (GSocket *socket);

Gets the unicast time-to-live setting on `socket` ; see `g_socket_set_ttl()` for more details.

#### Parameters

socket | a GSocket. |

#### Returns

the time-to-live setting on `socket`

Since: 2.32

### g_socket_get_broadcast ()

    gboolean
    g_socket_get_broadcast (GSocket *socket);

Gets the broadcast setting on `socket` ; if `TRUE`, it is possible to send packets to broadcast addresses.

#### Parameters

socket | a GSocket. |

#### Returns

the broadcast setting on `socket`

Since: 2.32

### g_socket_set_broadcast ()

    void
    g_socket_set_broadcast (GSocket *socket,
                            gboolean broadcast);

Sets whether `socket` should allow sending to broadcast addresses. This is `FALSE` by default.

#### Parameters

socket | a GSocket. |
broadcast | whether `socket` should allow sending to broadcast addresses |

Since: 2.32

### g_socket_get_option ()

    gboolean
    g_socket_get_option (GSocket *socket,
                         gint level,
                         gint optname,
                         gint *value,
                         GError **error);

Gets the value of an integer-valued option on `socket` , as with `getsockopt()`. (If you need to fetch a non-integer-valued option, you will need to call `getsockopt()` directly.)

The <gio/gnetworking.h> header pulls in system headers that will define most of the standard/portable socket options. For unusual socket protocols or platform-dependent options, you may need to include additional headers.

Note that even for socket options that are a single byte in size, `value` is still a pointer to a gint variable, not a guchar; `g_socket_get_option()` will handle the conversion internally.

#### Parameters

socket | a GSocket |
level | the "API level" of the option (eg, `SOL_SOCKET`) |
optname | the "name" of the option (eg, `SO_BROADCAST`) |
value | return location for the option value. | [out]
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

success or failure. On failure, `error` will be set, and the system error value (`errno` or `WSAGetLastError()`) will still be set to the result of the `getsockopt()` call.

Since: 2.36

### g_socket_set_option ()

    gboolean
    g_socket_set_option (GSocket *socket,
                         gint level,
                         gint optname,
                         gint value,
                         GError **error);

Sets the value of an integer-valued option on `socket` , as with `setsockopt()`. (If you need to set a non-integer-valued option, you will need to call `setsockopt()` directly.)

The <gio/gnetworking.h> header pulls in system headers that will define most of the standard/portable socket options. For unusual socket protocols or platform-dependent options, you may need to include additional headers.

#### Parameters

socket | a GSocket |
level | the "API level" of the option (eg, `SOL_SOCKET`) |
optname | the "name" of the option (eg, `SO_BROADCAST`) |
value | the value to set the option to |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

success or failure. On failure, `error` will be set, and the system error value (`errno` or `WSAGetLastError()`) will still be set to the result of the `setsockopt()` call.

Since: 2.36

### g_socket_get_family ()

    GSocketFamily
    g_socket_get_family (GSocket *socket);

Gets the socket family of the socket.

#### Parameters

socket | a GSocket. |

#### Returns

a GSocketFamily

Since: 2.22

### g_socket_get_fd ()

    int
    g_socket_get_fd (GSocket *socket);

Returns the underlying OS socket object. On unix this is a socket file descriptor, and on Windows this is a Winsock2 SOCKET handle. This may be useful for doing platform specific or otherwise unusual operations on the socket.

#### Parameters

socket | a GSocket. |

#### Returns

the file descriptor of the socket.

Since: 2.22

### g_socket_get_local_address ()

    GSocketAddress *
    g_socket_get_local_address (GSocket *socket,
                                GError **error);

Try to get the local address of a bound socket. This is only useful if the socket has been bound to a local address, either explicitly or implicitly when connecting.

#### Parameters

socket | a GSocket. |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

a GSocketAddress or `NULL` on error. Free the returned object with `g_object_unref()`.

[transfer full]

Since: 2.22

### g_socket_get_protocol ()

    GSocketProtocol
    g_socket_get_protocol (GSocket *socket);

Gets the socket protocol id the socket was created with. In case the protocol is unknown, -1 is returned.

#### Parameters

socket | a GSocket. |

#### Returns

a protocol id, or -1 if unknown

Since: 2.22

### g_socket_get_remote_address ()

    GSocketAddress *
    g_socket_get_remote_address (GSocket *socket,
                                 GError **error);

Try to get the remove address of a connected socket. This is only useful for connection oriented sockets that have been connected.

#### Parameters

socket | a GSocket. |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

a GSocketAddress or `NULL` on error. Free the returned object with `g_object_unref()`.

[transfer full]

Since: 2.22

### g_socket_get_socket_type ()

    GSocketType
    g_socket_get_socket_type (GSocket *socket);

Gets the socket type of the socket.

#### Parameters

socket | a GSocket. |

#### Returns

a GSocketType

Since: 2.22

### g_socket_speaks_ipv4 ()

    gboolean
    g_socket_speaks_ipv4 (GSocket *socket);

Checks if a socket is capable of speaking IPv4.

IPv4 sockets are capable of speaking IPv4. On some operating systems and under some combinations of circumstances IPv6 sockets are also capable of speaking IPv4. See RFC 3493 section 3.7 for more information.

No other types of sockets are currently considered as being capable of speaking IPv4.

#### Parameters

socket | a GSocket |

#### Returns

`TRUE` if this socket can be used with IPv4.

Since: 2.22

### g_socket_get_credentials ()

    GCredentials *
    g_socket_get_credentials (GSocket *socket,
                              GError **error);

Returns the credentials of the foreign process connected to this socket, if any (e.g. it is only supported for `G_SOCKET_FAMILY_UNIX` sockets).

If this operation isn't supported on the OS, the method fails with the `G_IO_ERROR_NOT_SUPPORTED` error. On Linux this is implemented by reading the `SO_PEERCRED` option on the underlying socket.

Other ways to obtain credentials from a foreign peer includes the GUnixCredentialsMessage type and `g_unix_connection_send_credentials()` / `g_unix_connection_receive_credentials()` functions.

#### Parameters

socket | a GSocket. |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`NULL` if `error` is set, otherwise a GCredentials object that must be freed with `g_object_unref()`.

[transfer full]

Since: 2.26

### g_socket_join_multicast_group ()

    gboolean
    g_socket_join_multicast_group (GSocket *socket,
                                   GInetAddress *group,
                                   gboolean source_specific,
                                   const gchar *iface,
                                   GError **error);

Registers `socket` to receive multicast messages sent to `group` . `socket` must be a `G_SOCKET_TYPE_DATAGRAM` socket, and must have been bound to an appropriate interface and port with `g_socket_bind()`.

If `iface` is `NULL`, the system will automatically pick an interface to bind to based on `group` .

If `source_specific` is `TRUE`, source-specific multicast as defined in RFC 4604 is used. Note that on older platforms this may fail with a `G_IO_ERROR_NOT_SUPPORTED` error.

#### Parameters

socket | a GSocket. |
group | a GInetAddress specifying the group address to join. |
iface | Name of the interface to use, or `NULL`. | [allow-none]
source_specific | `TRUE` if source-specific multicast should be used |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` on error.

Since: 2.32

### g_socket_leave_multicast_group ()

    gboolean
    g_socket_leave_multicast_group (GSocket *socket,
                                    GInetAddress *group,
                                    gboolean source_specific,
                                    const gchar *iface,
                                    GError **error);

Removes `socket` from the multicast group defined by `group` , `iface` , and `source_specific` (which must all have the same values they had when you joined the group).

`socket` remains bound to its address and port, and can still receive unicast messages after calling this.

#### Parameters

socket | a GSocket. |
group | a GInetAddress specifying the group address to leave. |
iface | Interface used. | [allow-none]
source_specific | `TRUE` if source-specific multicast was used |
error | GError for error reporting, or `NULL` to ignore. |

#### Returns

`TRUE` on success, `FALSE` on error.

Since: 2.32

### g_socket_get_multicast_loopback ()

    gboolean
    g_socket_get_multicast_loopback (GSocket *socket);

Gets the multicast loopback setting on `socket` ; if `TRUE` (the default), outgoing multicast packets will be looped back to multicast listeners on the same host.

#### Parameters

socket | a GSocket. |

#### Returns

the multicast loopback setting on `socket`

Since: 2.32

### g_socket_set_multicast_loopback ()

    void
    g_socket_set_multicast_loopback (GSocket *socket,
                                     gboolean loopback);

Sets whether outgoing multicast packets will be received by sockets listening on that multicast address on the same host. This is `TRUE` by default.

#### Parameters

socket | a GSocket. |
loopback | whether `socket` should receive messages sent to its multicast groups from the local host |

Since: 2.32

### g_socket_get_multicast_ttl ()

    guint
    g_socket_get_multicast_ttl (GSocket *socket);

Gets the multicast time-to-live setting on `socket` ; see `g_socket_set_multicast_ttl()` for more details.

#### Parameters

socket | a GSocket. |

#### Returns

the multicast time-to-live setting on `socket`

Since: 2.32

### g_socket_set_multicast_ttl ()

    void
    g_socket_set_multicast_ttl (GSocket *socket,
                                guint ttl);

Sets the time-to-live for outgoing multicast datagrams on `socket` . By default, this is 1, meaning that multicast packets will not leave the local network.

#### Parameters

socket | a GSocket. |
ttl | the time-to-live value for all multicast datagrams on `socket` |

Since: 2.32

## Types and Values

### GSocket

    typedef struct _GSocket GSocket;

A lowlevel network socket object.

Since: 2.22

### enum GSocketType

Flags used when creating a GSocket. Some protocols may not implement all the socket types.

#### Members

G_SOCKET_TYPE_INVALID | Type unknown or wrong |
G_SOCKET_TYPE_STREAM | Reliable connection-based byte streams (e.g. TCP). |
G_SOCKET_TYPE_DATAGRAM | Connectionless, unreliable datagram passing. (e.g. UDP) |
G_SOCKET_TYPE_SEQPACKET | Reliable connection-based passing of datagrams of fixed maximum length (e.g. SCTP). |

Since: 2.22

### enum GSocketProtocol

A protocol identifier is specified when creating a GSocket, which is a family/type specific identifier, where 0 means the default protocol for the particular family/type.

This enum contains a set of commonly available and used protocols. You can also pass any other identifiers handled by the platform in order to use protocols not listed here.

#### Members

G_SOCKET_PROTOCOL_UNKNOWN | The protocol type is unknown |
G_SOCKET_PROTOCOL_DEFAULT | The default protocol for the family/type |
G_SOCKET_PROTOCOL_TCP | TCP over IP |
G_SOCKET_PROTOCOL_UDP | UDP over IP |
G_SOCKET_PROTOCOL_SCTP | SCTP over IP |

Since: 2.22

### enum GSocketMsgFlags

Flags used in `g_socket_receive_message()` and `g_socket_send_message()`. The flags listed in the enum are some commonly available flags, but the values used for them are the same as on the platform, and any other flags are passed in/out as is. So to use a platform specific flag, just include the right system header and pass in the flag.

#### Members

G_SOCKET_MSG_NONE | No flags. |
G_SOCKET_MSG_OOB | Request to send/receive out of band data. |
G_SOCKET_MSG_PEEK | Read data from the socket without removing it from the queue. |
G_SOCKET_MSG_DONTROUTE | Don't use a gateway to send out the packet, only send to hosts on directly connected networks. |

Since: 2.22

### struct GInputVector

    struct GInputVector {
      gpointer buffer;
      gsize size;
    };

Structure used for scatter/gather data input. You generally pass in an array of GInputVectors and the operation will store the read data starting in the first buffer, switching to the next as needed.

#### Members

gpointer `buffer`; | Pointer to a buffer where data will be written. |
gsize `size`; | the available size in `buffer` . |

Since: 2.22

### struct GInputMessage

    struct GInputMessage {
      GSocketAddress         **address;

      GInputVector            *vectors;
      guint                    num_vectors;

      gsize                    bytes_received;
      gint                     flags;

      GSocketControlMessage ***control_messages;
      guint                   *num_control_messages;
    };

Structure used for scatter/gather data input when receiving multiple messages or packets in one go. You generally pass in an array of empty GInputVectors and the operation will use all the buffers as if they were one buffer, and will set `bytes_received` to the total number of bytes received across all GInputVectors.

This structure closely mirrors `struct mmsghdr` and `struct msghdr` from the POSIX sockets API (see `man 2 recvmmsg`).

If `address` is non-`NULL` then it is set to the source address the message was received from, and the caller must free it afterwards.

If `control_messages` is non-`NULL` then it is set to an array of control messages received with the message (if any), and the caller must free it afterwards. `num_control_messages` is set to the number of elements in this array, which may be zero.

Flags relevant to this message will be returned in `flags` . For example, `MSG_EOR` or `MSG_TRUNC`.

#### Members

GSocketAddress **`address`; | return location for a GSocketAddress, or `NULL`. | [optional][out][transfer full]
GInputVector *`vectors`; | pointer to an array of input vectors. | [array length=num_vectors][out]
guint `num_vectors`; | the number of input vectors pointed to by `vectors` |
gsize `bytes_received`; | will be set to the number of bytes that have been received. | [out]
gint `flags`; | collection of GSocketMsgFlags for the received message, outputted by the call. | [out]
GSocketControlMessage ***`control_messages`; | (array length=num_control_messages) (optional) (out) (transfer full): return location for a caller-allocated array of GSocketControlMessages, or `NULL` |
guint *`num_control_messages`; | return location for the number of elements in `control_messages` . | [out][optional]

Since: 2.48

### struct GOutputVector

    struct GOutputVector {
      gconstpointer buffer;
      gsize size;
    };

Structure used for scatter/gather data output. You generally pass in an array of GOutputVectors and the operation will use all the buffers as if they were one buffer.

#### Members

gconstpointer `buffer`; | Pointer to a buffer of data to read. |
gsize `size`; | the size of `buffer` . |

Since: 2.22

### struct GOutputMessage

    struct GOutputMessage {
      GSocketAddress         *address;

      GOutputVector          *vectors;
      guint                   num_vectors;

      guint                   bytes_sent;

      GSocketControlMessage **control_messages;
      guint                   num_control_messages;
    };

Structure used for scatter/gather data output when sending multiple messages or packets in one go. You generally pass in an array of GOutputVectors and the operation will use all the buffers as if they were one buffer.

If `address` is `NULL` then the message is sent to the default receiver (as previously set by `g_socket_connect()`).

#### Members

GSocketAddress *`address`; | a GSocketAddress, or `NULL`. | [allow-none]
GOutputVector *`vectors`; | pointer to an array of output vectors |
guint `num_vectors`; | the number of output vectors pointed to by `vectors` . |
guint `bytes_sent`; | initialize to 0. Will be set to the number of bytes that have been sent |
GSocketControlMessage **`control_messages`; | a pointer to an array of GSocketControlMessages, or `NULL`. | [array length=num_control_messages][allow-none]
guint `num_control_messages`; | number of elements in `control_messages` . |

Since: 2.44

## Property Details

### The `“blocking”` property

      “blocking”                 gboolean

Whether or not I/O on this socket is blocking.

Flags: Read / Write

Default value: TRUE

### The `“broadcast”` property

      “broadcast”                gboolean

Whether the socket should allow sending to broadcast addresses.

Flags: Read / Write

Default value: FALSE

Since: 2.32

### The `“family”` property

      “family”                   GSocketFamily

The sockets address family.

Flags: Read / Write / Construct Only

Default value: G_SOCKET_FAMILY_INVALID

### The `“fd”` property

      “fd”                       gint

The sockets file descriptor.

Flags: Read / Write / Construct Only

Default value: -1

### The `“keepalive”` property

      “keepalive”                gboolean

Keep connection alive by sending periodic pings.

Flags: Read / Write

Default value: FALSE

### The `“listen-backlog”` property

      “listen-backlog”           gint

Outstanding connections in the listen queue.

Flags: Read / Write

Allowed values: [0,128]

Default value: 10

### The `“local-address”` property

      “local-address”            GSocketAddress *

The local address the socket is bound to.

Flags: Read

### The `“multicast-loopback”` property

      “multicast-loopback”       gboolean

Whether outgoing multicast packets loop back to the local host.

Flags: Read / Write

Default value: TRUE

Since: 2.32

### The `“multicast-ttl”` property

      “multicast-ttl”            guint

Time-to-live out outgoing multicast packets

Flags: Read / Write

Default value: 1

Since: 2.32

### The `“protocol”` property

      “protocol”                 GSocketProtocol

The id of the protocol to use, or -1 for unknown.

Flags: Read / Write / Construct Only

Default value: G_SOCKET_PROTOCOL_UNKNOWN

### The `“remote-address”` property

      “remote-address”           GSocketAddress *

The remote address the socket is connected to.

Flags: Read

### The `“timeout”` property

      “timeout”                  guint

The timeout in seconds on socket I/O

Flags: Read / Write

Default value: 0

Since: 2.26

### The `“ttl”` property

      “ttl”                      guint

Time-to-live for outgoing unicast packets

Flags: Read / Write

Default value: 0

Since: 2.32

### The `“type”` property

      “type”                     GSocketType

The sockets type.

Flags: Read / Write / Construct Only

Default value: G_SOCKET_TYPE_STREAM

## See Also

GInitable, <gnetworking.h>